; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    inputx MACRO prompt:VARARG
      LOCAL txt
      LOCAL buffer
      IFNB <prompt>
        .data
          txt db prompt, 0
          align 4
        .data?
          buffer db 132 dup (?)
          align 4
        .code
        invoke StdOut,ADDR txt
        invoke StdIn,ADDR buffer,128
        mov BYTE PTR [buffer+eax], 0
        invoke StripLFx,ADDR buffer
        EXITM <OFFSET buffer>
      ELSE
        .data?
          buffer db 132 dup (?)
          align 4
        .code
        invoke StdIn,ADDR buffer,128
        mov BYTE PTR [buffer+eax], 0
        invoke StripLFx,ADDR buffer
        EXITM <OFFSET buffer>
      ENDIF
    ENDM

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pbuf  :DWORD
    LOCAL blen  :DWORD
    LOCAL phex  :DWORD

    mov pbuf, input("Enter text ",62," ")
    mov blen, len(pbuf)
    add eax, eax
    add eax, eax
    mov phex, alloc(eax)

    .data
      txt db "Howdy",13,10,"If you can you see me, it works. :)",13,10,0
    .code

    print OFFSET txt

    invoke bin2hex,pbuf,blen,phex
    print phex,13,10

    free phex

    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

StripLFx proc src:DWORD

    mov eax, [esp+4]
    sub eax, 1
  @@:
    add eax, 1
    cmp BYTE PTR [eax], 0
    je tlfout
    cmp BYTE PTR [eax], 13
    jne @B

    mov BYTE PTR [eax], 0
    ret 4

  tlfout:
    ret 4

StripLFx endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start
